## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global forgeurl https://github.com/qxmpp-project/qxmpp
Version:        1.7.1
%global sover   5
%forgemeta

%bcond_without check
%bcond_with all_tests

Name:           qxmpp
Release:        %autorelease
Summary:        Cross-platform C++ XMPP client and server library

# The library is under LGPL-2.1-or-later license
# the files in doc/ directory are CC0-1.0 license.
# the qxmpp logo is CC-BY-SA-4.0 license.
License:        LGPL-2.1-or-later AND CC0-1.0 AND CC-BY-SA-4.0
URL:            %{forgeurl}
Source0:        %{forgesource}

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  doxygen
# optional for QXmpp OMEMO module
BuildRequires:  libomemo-c-devel
BuildRequires:  protobuf-c-devel

%global _description %{expand:
QXmpp is a cross-platform C++ XMPP client and server library. It is written in
C++ and uses Qt framework.

QXmpp strives to be as easy to use as possible, the underlying TCP socket, the
core XMPP RFCs (RFC6120 and RFC6121) and XMPP extensions have been nicely
encapsulated into classes. QXmpp is ready to build XMPP clients complying with
the XMPP Compliance Suites 2022 for IM and Advanced Mobile. It comes with full
API documentation, automatic tests and some examples.}

%description
%{_description}

%package        qt5
Summary:        QXmpp library for Qt5
BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5Network)
BuildRequires:  cmake(Qt5Xml)
# optional for QXmpp OMEMO module
BuildRequires:  qca-qt5-devel

%description    qt5
%{_description}

%package        qt5-devel
Summary:        Development Files for %{name}-qt5
Requires:       %{name}-qt5%{?_isa} = %{version}-%{release}

%description    qt5-devel
This package contains libraries and header files for developing applications
that use %{name}-qt5.

%package        qt6
Summary:        QXmpp library for Qt6
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6Network)
BuildRequires:  cmake(Qt6Xml)
BuildRequires:  cmake(Qt6Core5Compat)
# optional for QXmpp OMEMO module
BuildRequires:  qca-qt6-devel

%description    qt6
%{_description}

%package        qt6-devel
Summary:        Development Files for %{name}-qt6
Requires:       %{name}-qt6%{?_isa} = %{version}-%{release}

%description    qt6-devel
This package contains libraries and header files for developing applications
that use %{name}-qt6.

%package        doc
Summary:        Documentation for %{name}
BuildArch:      noarch

%description    doc
This package contains documentation for %{name}.

%prep
%forgeautosetup -p1

%build
OPTIONS=(
    -GNinja \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_TESTS=ON \
    -DBUILD_DOCUMENTATION=ON \
    -DBUILD_OMEMO=ON \
)
%global _vpath_builddir %{_target_platform}-qt5
%cmake \
    ${OPTIONS[@]} \
    -DQT_VERSION_MAJOR=5 \
%cmake_build

%global _vpath_builddir %{_target_platform}-qt6
%cmake \
    ${OPTIONS[@]} \
    -DQT_VERSION_MAJOR=6 \
%cmake_build

%install
%global _vpath_builddir %{_target_platform}-qt5
%cmake_install

%global _vpath_builddir %{_target_platform}-qt6
%cmake_install

%if %{with check}
%check
%global _vpath_builddir %{_target_platform}-qt5
%if %{with all_tests}
%ctest
%else
# https://koji.fedoraproject.org/koji/taskinfo?taskID=102206908
SKIP_TESTS=
SKIP_TESTS='tst_qxmppiceconnection'
SKIP_TESTS+='|tst_qxmppfileencryption'
SKIP_TESTS+='|tst_qxmpptransfermanager'
%endif

%global _vpath_builddir %{_target_platform}-qt6
%if %{with all_tests}
%ctest
%else
# https://koji.fedoraproject.org/koji/taskinfo?taskID=102207489
SKIP_TESTS=
SKIP_TESTS='tst_qxmppdiscoverymanager'
SKIP_TESTS+='|tst_qxmppiceconnection'
SKIP_TESTS+='|tst_qxmpppubsubmanager'
SKIP_TESTS+='|tst_qxmpprostermanager'
SKIP_TESTS+='|tst_qxmppuserlocationmanager'
SKIP_TESTS+='|tst_qxmppusertunemanager'
SKIP_TESTS+='|tst_qxmppfileencryption'
SKIP_TESTS+='|tst_qxmpptransfermanager'
SKIP_TESTS+='|tst_qxmpphttpuploadmanager'
%ctest -E "$SKIP_TESTS"
%endif

%endif

%files qt5
%license LICENSES/*
%doc README.md
%{_libdir}/libQXmppQt5.so.%{sover}
%{_libdir}/libQXmppQt5.so.%{version}
%{_libdir}/libQXmppOmemoQt5.so.%{sover}
%{_libdir}/libQXmppOmemoQt5.so.%{version}

%files qt5-devel
%{_libdir}/libQXmppQt5.so
%{_libdir}/libQXmppOmemoQt5.so
%dir %{_includedir}/QXmppQt5
%{_includedir}/QXmppQt5/*.h
%{_includedir}/QXmppQt5/*.cpp
%{_includedir}/QXmppQt5/Omemo/
%{_libdir}/cmake/QXmppQt5/
%{_libdir}/cmake/QXmppOmemoQt5/
%{_libdir}/cmake/QXmpp/
%{_libdir}/pkgconfig/QXmppQt5.pc
%{_libdir}/pkgconfig/qxmpp.pc

%files qt6
%license LICENSES/*
%doc README.md
%{_libdir}/libQXmppQt6.so.%{sover}
%{_libdir}/libQXmppQt6.so.%{version}
%{_libdir}/libQXmppOmemoQt6.so.%{sover}
%{_libdir}/libQXmppOmemoQt6.so.%{version}

%files qt6-devel
%{_libdir}/libQXmppQt6.so
%{_libdir}/libQXmppOmemoQt6.so
%dir %{_includedir}/QXmppQt6
%{_includedir}/QXmppQt6/*.h
%{_includedir}/QXmppQt6/*.cpp
%{_includedir}/QXmppQt6/Omemo/
%{_libdir}/cmake/QXmppQt6/
%{_libdir}/cmake/QXmppOmemoQt6/
%{_libdir}/cmake/QXmpp/
%{_libdir}/pkgconfig/QXmppQt6.pc
%{_libdir}/pkgconfig/qxmpp.pc

%files doc
%dir %{_docdir}/qxmpp
%{_docdir}/qxmpp/html/

%changelog
## START: Generated by rpmautospec
* Mon Jul 08 2024 Packit <hello@packit.dev> - 1.7.1-1
- Update to 1.7.1 upstream release
- Resolves: rhbz#2280919

* Sun May 26 2024 topazus <topazus@outlook.com> - 1.7.0-1
- 1.7.0

* Fri May 17 2024 topazus <topazus@outlook.com> - 1.6.1-1
- 1.6.1

* Wed Feb 07 2024 Packit <hello@packit.dev> - 1.6.0-1
- [packit] 1.6.0 upstream release
- Resolves rhbz#2262826

* Mon Feb 05 2024 Packit <hello@packit.dev> - 1.5.6-1
- [packit] 1.5.6 upstream release

* Mon Feb 05 2024 topazus <topazus@outlook.com> - 1.5.5-7
- fix packit config

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Nov 28 2023 topazus <topazus@outlook.com> - 1.5.5-4
- modify packit config file

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Wed Jun 21 2023 topazus <topazus@outlook.com> - 1.5.5-2
- add Packit CI

* Wed Jun 21 2023 topazus <topazus@outlook.com> - 1.5.5-1
- update to 1.5.5

* Wed Jun 21 2023 Tomas Hrcka <thrcka@redhat.com> - 0.9.3-19
- Unretirement request: https://pagure.io/releng/issue/11493

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Fri Jan 08 2021 Tom Stellard <tstellar@redhat.com> - 0.9.3-14
- Add BuildRequires: make

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Tue Jan 22 2019 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.9.3-9
- Remove obsolete ldconfig scriptlets

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-6
- Rebuilt for
  https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Feb 01 2016 Rex Dieter <rdieter@math.unl.edu> - 0.9.3-2
- use %%qmake_qt5/%%qmake_qt4 macros to ensure proper build flags

* Mon Dec 21 2015 Minh Ngo <nlminhtl@gmail.com> - 0.9.3-1
- v0.9.3

* Thu Sep 03 2015 Minh Ngo <nlminhtl@gmail.com> - 0.9.2-1
- v0.9.2. Packages for qt5 and documentation.

* Sat Aug 29 2015 Minh Ngo <nlminhtl@gmail.com> - 0.9.0-3
- Adding doxygen to dependencies

* Sat Aug 29 2015 Minh Ngo <nlminhtl@gmail.com> - 0.9.0-2
- Updating .gitignore

* Sat Aug 29 2015 Minh Ngo <nlminhtl@gmail.com> - 0.9.0-1
- v0.9.0

* Thu Jun 18 2015 Dennis Gilmore <dennis@ausil.us> - 0.7.5-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 0.7.5-6
- Rebuilt for GCC 5 C++11 ABI change

* Sun Aug 17 2014 Peter Robinson <pbrobinson@fedoraproject.org> - 0.7.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Dennis Gilmore <dennis@ausil.us> - 0.7.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Dec 13 2013 Michael Schwendt <mschwendt@fedoraproject.org> - 0.7.5-3
- Fix duplicate documentation (#1001295) [Fix bogus dates in %%changelog]

* Sun Aug 04 2013 Dennis Gilmore <dennis@ausil.us> - 0.7.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Minh Ngo <nlminhtl@gmail.com> - 0.7.5-1
- 0.7.4-1

* Fri Nov 09 2012 Minh Ngo <nlminhtl@gmail.com> - 0.7.4-1
- 0.7.4

* Sat Sep 29 2012 Minh Ngo <nlminhtl@gmail.com> - 0.7.3-5
- 0.7.3-4

* Thu Sep 27 2012 Minh Ngo <nlminhtl@gmail.com> - 0.7.3-4
- 0.7.3-2

* Thu Sep 27 2012 Minh Ngo <nlminhtl@gmail.com> - 0.7.3-3
- Fixing a source archive

* Thu Sep 27 2012 Minh Ngo <nlminhtl@gmail.com> - 0.7.3-2
- Some fixes

* Thu Sep 27 2012 Minh Ngo <nlminhtl@gmail.com> - 0.7.3-1
- 0.7.3
## END: Generated by rpmautospec
